std::is_member_object_pointer(3)

NAME
std::is_member_object_pointer - std::is_member_object_pointer

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_member_object_pointer;
   Checks whether T is a non-static member object pointer. Provides the member constant
   value which is equal to true, if T is a non-static member object pointer type.
   Otherwise, value is equal to false.
   The behavior of a program that adds specializations for is_member_object_pointer
   or is_member_object_pointer_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T >
   inline constexpr bool is_member_object_pointer_v = (since C++17)
   is_member_object_pointer<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a pointer to member object , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   template<class T>
   struct is_member_object_pointer : std::integral_constant<
                        bool,
                        std::is_member_pointer<T>::value &&
                        !std::is_member_function_pointer<T>::value
                        > {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 int main()
 {
     class C {};
     std::cout << "Is member object pointer?\n" << std::boolalpha
               << std::is_member_object_pointer_v<int(C::*)>
               << ": int(C::*)\n"
               << std::is_member_object_pointer_v<int(C::*)()>
               << ": int(C::*)()\n";
 }

Output:
 Is member object pointer?
 true: int(C::*)
 false: int(C::*)()

See also
   is_pointer checks if a type is a pointer type
   (C++11) (class template)
   is_member_pointer checks if a type is a pointer to an non-static member
   (C++11) function or object
                        (class template)
   is_member_function_pointer checks if a type is a pointer to a non-static member
   (C++11) function
                        (class template)